//----------------------------------------------------------------------//
// NyanFi																//
//  o^fBNg/tH_ꗗ									//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <algorithm>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "MainFrm.h"
#include "DirDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRegDirDlg *RegDirDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TRegDirDlg::TRegDirDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormCreate(TObject *Sender)
{
	ListScrPanel = new UsrScrollPanel(ListPanel, RegDirListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);

	IsSpecial = false;
}

//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormShow(TObject *Sender)
{
	Caption = IsSpecial? "tH_ꗗ" : "o^fBNg";

	IniFile->LoadPosInfo(this, DialogCenter, (IsSpecial? _T("SpecialDirList") : null_TCHAR));

	InitializeListHeader(RegDirHeader, _T("L[|O|ꏊ"));
	THeaderSections *sp = RegDirHeader->Sections;
	sp->Items[0]->MaxWidth = IsSpecial? 0 : 1000;

	TListBox *lp = RegDirListBox;
	set_StdListBox(lp, LBTAG_OPT_FOCS);
	set_UsrScrPanel(ListScrPanel);

	//tH_
	if (IsSpecial) {
		OptPanel->Visible	= false;
		BlankPanel->Visible = false;

		//ꗗ擾([NXg`)
		std::unique_ptr<TStringList> lst(new TStringList());
		usr_SH->get_SpecialFolderList(lst.get());

		//O̍ő啝擾
		int n_wd = 0;
		for (int i=0; i<lst->Count; i++) {
			TStringDynArray itm_buf = split_strings_tab(lst->Strings[i]);
			if (itm_buf.Length==2) n_wd = std::max(n_wd, lp->Canvas->TextWidth(itm_buf[1]));
		}
		sp->Items[0]->Width = 0;
		sp->Items[1]->Width = n_wd + ScaledInt(24);
		adjust_HeaderSecWidth(RegDirHeader, 2);

		lp->Items->Assign(lst.get());
		lp->ItemIndex = IndexOfDir(CurPathName);
	}
	//o^fBNg
	else {
		set_ButtonMark(HideOptBtn, UBMK_BDOWN);
		set_ButtonMark(ShowOptBtn, UBMK_BUP);
		HideOptBtn->Hint = LoadUsrMsg(USTR_HideOptPanel);
		ShowOptBtn->Hint = LoadUsrMsg(USTR_ShowOptPanel);

		MoveTopCheckBox->Checked = IniFile->ReadBoolGen(_T("RegDirDlgMoveTop"));
		OptPanel->Visible		 = IniFile->ReadBoolGen(_T("RegDirDlgShowOpt"),  true);
		BlankPanel->Visible 	 = !OptPanel->Visible;
		SetOptBtn();

		sp->Items[0]->Width = IniFile->ReadInteger("RegDirGrid", "ColWidth0",	40);
		sp->Items[1]->Width = IniFile->ReadInteger("RegDirGrid", "ColWidth1",	200);
		adjust_HeaderSecWidth(RegDirHeader, 2);

		lp->Items->Assign(RegDirList);
		lp->ItemIndex = IndexOfDir(CurPathName);
		if (lp->ItemIndex==-1) {
			KeyEdit->Text  = EmptyStr;
			DescEdit->Text = EmptyStr;
		}
		DirEdit->Text = CurPathName;
	}

	lp->SetFocus();
	ListScrPanel->UpdateKnob();

	UserModule->InitializeListBox(lp, ListScrPanel);
	SelIndex = -1;
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	UserModule->UninitializeListBox();

	if (!IsSpecial) {
		TListBox *lp = RegDirListBox;
		for (int i=0; i<lp->Count; i++) {
			if (is_separator(get_csv_item(lp->Items->Strings[i], 1))) lp->Items->Strings[i] = ",-,";
		}
		RegDirList->Assign(lp->Items);

		//gpڂZp[^lĐ擪ֈړ
		if (MoveTopCheckBox->Checked) move_top_RegDirItem(SelIndex);

		IniFile->WriteBoolGen(_T("RegDirDlgMoveTop"),	MoveTopCheckBox);
		IniFile->WriteBoolGen(_T("RegDirDlgShowOpt"),	OptPanel->Visible);

		THeaderSections *sp = RegDirHeader->Sections;
		IniFile->WriteInteger("RegDirGrid", "ColWidth0",	sp->Items[0]->Width);
		IniFile->WriteInteger("RegDirGrid", "ColWidth1",	sp->Items[1]->Width);
	}

	IniFile->SavePosInfo(this, (IsSpecial? _T("SpecialDirList"): null_TCHAR));

	IsSpecial = false;
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormDestroy(TObject *Sender)
{
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormResize(TObject *Sender)
{
	if (!IsSpecial) SetOptBtn();

	RegDirListBox->Invalidate();
}

//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirHeaderDrawSection(THeaderControl *HeaderControl,
	THeaderSection *Section, const TRect &Rect, bool Pressed)
{
	draw_SortHeader(HeaderControl, Section, Rect);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirHeaderResize(TObject *Sender)
{
	adjust_HeaderSecWidth((THeaderControl *)Sender, 2);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirHeaderSectionResize(THeaderControl *HeaderControl, THeaderSection *Section)
{
	adjust_HeaderSecWidth(HeaderControl, 2);
	RegDirListBox->Repaint();
}

//---------------------------------------------------------------------------
int __fastcall TRegDirDlg::IndexOfDir(UnicodeString dnam)
{
	int idx = -1;
	dnam = IncludeTrailingPathDelimiter(dnam);
	TListBox *lp = RegDirListBox;

	if (IsSpecial) {
		for (int i=0; i<lp->Count && idx==-1; i++) {
			if (SameText(get_pre_tab(lp->Items->Strings[i]), dnam)) idx = i;
		}
		//v̂Ȃ΁Aԋ߂eT
		if (idx==-1) {
			UnicodeString max_nam;
			for (int i=0; i<lp->Count; i++) {
				UnicodeString pnam = get_pre_tab(lp->Items->Strings[i]);
				if (StartsText(pnam, dnam)) {
					if (pnam.Length()>max_nam.Length()) {
						max_nam = pnam;
						idx = i;
					}
				}
			}
		}
	}
	else {
		for (int i=0; i<lp->Count && idx==-1; i++) {
			if (SameText(get_csv_item(lp->Items->Strings[i], 2), dnam)) idx = i;
		}
	}

	return idx;
}

//---------------------------------------------------------------------------
UnicodeString __fastcall TRegDirDlg::GetCurDirItem()
{
	TListBox *lp = RegDirListBox;
	if (lp->ItemIndex!=-1) {
		UnicodeString lbuf = lp->Items->Strings[lp->ItemIndex];
		if (IsSpecial) {
			TStringDynArray itm_buf = split_strings_tab(lbuf);
			if (itm_buf.Length==2 && !itm_buf[0].IsEmpty()) return itm_buf[0];
		}
		else {
			TStringDynArray itm_buf = get_csv_array(lbuf, 3, true);
			if (!is_separator(itm_buf[1])) return itm_buf[2];
		}
	}

	return EmptyStr;
}

//---------------------------------------------------------------------------
//L[
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString KeyStr = get_KeyStr(Key, Shift);
	UnicodeString cmd_F  = Key_to_CmdF(KeyStr);

	TListBox *lp = RegDirListBox;

	bool handled = true;
	if (USAME_TI(KeyStr, "UP") && lp->ItemIndex==0)
		lp->ItemIndex = lp->Count - 1;
	else if (USAME_TI(KeyStr, "DOWN") && lp->ItemIndex==lp->Count-1)
		lp->ItemIndex = 0;
	else if (contained_wd_i(KeysStr_Popup, KeyStr))
		show_PopupMenu(lp);
	else if (IsSpecial && ExeCmdListBox(lp, cmd_F))
		;
	else if (!IsSpecial && UserModule->ListBoxOpeItem(KeyStr))
		;
	//vpeB
	else if (USAME_TI(cmd_F, "PropertyDlg")) {
		UnicodeString dnam = GetCurDirItem();
		if (!dnam.IsEmpty()) {
			pos_ListBoxItem(lp);
			ShowPropertyDialog(dnam);
		}
	}
	else handled = false;

	if (handled) Key = 0;

	ListScrPanel->UpdateKnob();
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	UnicodeString jdir;
	bool found = false;
	SelIndex = -1;

	TListBox *lp = (TListBox*)Sender;
	if (Key==VK_RETURN) {
		jdir = GetCurDirItem();
		if (!jdir.IsEmpty()) {
			SelIndex = lp->ItemIndex;
			found = true;
		}
	}
	else if (!IsSpecial && !is_KeyDown(VK_CONTROL)) {
		//YL[̓o^JEg
		int f_cnt = 0;
		UnicodeString k = Key;
		for (int i=0; i<lp->Count; i++) {
			TStringDynArray itm_buf = get_csv_array(lp->Items->Strings[i], 3, true);
			if (SameText(k, itm_buf[0])) {
				jdir = itm_buf[2];
				SelIndex = i;
				f_cnt++;
			}
		}

		if		(f_cnt==0) beep_Warn();
		else if (f_cnt==1) found = true;
	}

	//m
	if (found) {
		NyanFiForm->RecoverFileList2();
		UnicodeString dnam = get_actual_path(jdir);
		if (is_dir_accessible(dnam)) {
			NyanFiForm->UpdateCurPath(dnam);
			Close();
		}
		else msgbox_ERR(SysErrorMessage(ERROR_ACCESS_DENIED));
	}

	//tH_ꗗł̃CN^T[`
	if (IsSpecial && (_istalnum(Key) || Key==VK_SPACE || Key==VK_RETURN || is_KeyDown(VK_CONTROL))) Key = 0;
}
//---------------------------------------------------------------------------
//}EX
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxDblClick(TObject *Sender)
{
	WideChar key = VK_RETURN;
	RegDirListBoxKeyPress(Sender, key);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxClick(TObject *Sender)
{
	if (IsSpecial) return;

	int idx = RegDirListBox->ItemIndex;  if (idx==-1) return;
	TStringDynArray itm_buf = get_csv_array(RegDirListBox->Items->Strings[idx], 3, true);
	if (is_separator(itm_buf[1])) itm_buf[0] = itm_buf[2] = EmptyStr;
	KeyEdit->Text  = itm_buf[0];
	DescEdit->Text = itm_buf[1];
	DirEdit->Text  = itm_buf[2];
}

//---------------------------------------------------------------------------
//ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Font->Assign(ListFont);

	cv->Brush->Color = col_bgList;
	cv->FillRect(Rect);

	//tH_
	if (IsSpecial) {
		TStringDynArray itm_buf = split_strings_tab(lp->Items->Strings[Index]);
		if (itm_buf.Length==2) {
			int xp = Rect.Left + 4;
			int yp = Rect.Top + get_TopMargin2(cv);
			//Zp[^
			if (itm_buf[0].IsEmpty()) {
				draw_Separator(cv, Rect);
				cv->Font->Color = col_Folder;
				cv->TextOut(xp, yp, "<All Users> ");
			}
			//
			else {
				THeaderSections *sp = RegDirHeader->Sections;
				cv->Font->Color = is_SelFgCol(State)? col_fgSelItem : col_fgList;
				cv->TextOut(xp, yp, itm_buf[1]);
				xp = sp->Items[1]->Width + 1;
				cv->Font->Color = col_Folder;
				PathNameOut(ExcludeTrailingPathDelimiter(itm_buf[0]), cv, xp, yp, sp->Items[2]->Width);
				if (lp->Items->Objects[Index]) draw_separateLine(cv, Rect);
			}
		}
	}
	//o^fBNg
	else {
		TStringDynArray itm_buf = get_csv_array(lp->Items->Strings[Index], 3, true);
		//Zp[^
		if (is_separator(itm_buf[1]))
			draw_Separator(cv, Rect);
		//
		else {
			THeaderSections *sp = RegDirHeader->Sections;
			cv->Font->Color = is_SelFgCol(State)? col_fgSelItem : col_fgList;
			cv->Font->Style = cv->Font->Style << fsBold;
			int s_wd = cv->TextWidth(itm_buf[0]);
			int c_wd = sp->Items[0]->Width - 4;
			int xp = Rect.Left + 2;
			int yp = Rect.Top + get_TopMargin2(cv);
			if (s_wd<c_wd) xp += (c_wd - s_wd)/2;	//Z^O
			cv->TextOut(xp, yp, itm_buf[0]);
			xp = sp->Items[0]->Width + 1;
			cv->Font->Style = cv->Font->Style >> fsBold;
			cv->TextOut(xp, yp, itm_buf[1]);
			xp += sp->Items[1]->Width + 1;
			cv->Font->Color = col_Folder;
			PathNameOut(itm_buf[2], cv, xp, yp, sp->Items[2]->Width);
		}
	}

	//J[\
	draw_ListCursor2(lp, Rect, Index, State);
}

//---------------------------------------------------------------------------
//ڂ̒ǉEύX
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::ChangeItemActionExecute(bool add)
{
	if (add && IndexOfDir(DirEdit->Text)!=-1) {
		msgbox_WARN(USTR_Registered);
		return;
	}

	if (is_separator(DescEdit->Text) || dir_exists(get_actual_path(DirEdit->Text))) {
		UnicodeString lbuf;
		if (is_separator(DescEdit->Text))
			lbuf.USET_T(",-,");
		else {
			lbuf = KeyEdit->Text.SubString(1, 1).UpperCase();
			lbuf.cat_sprintf(_T(",%s,%s"),
				make_csv_str(DescEdit->Text).c_str(),
				make_csv_str(IncludeTrailingPathDelimiter(DirEdit->Text)).c_str());
		}

		TListBox *lp = RegDirListBox;
		if (add) {
			lp->Items->Add(lbuf);
			lp->ItemIndex = lp->Count - 1;
		}
		else {
			if (lp->ItemIndex==-1) return;
			lp->Items->Strings[lp->ItemIndex] = lbuf;
		}

		lp->SetFocus();
		ListScrPanel->UpdateKnob();
	}
	else msgbox_WARN(USTR_DirNotFound);
}

//---------------------------------------------------------------------------
//ύX
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::EditItemActionExecute(TObject *Sender)
{
	ChangeItemActionExecute(false);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::EditItemActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (!IsSpecial && RegDirListBox->ItemIndex!=-1);
}
//---------------------------------------------------------------------------
//ǉ
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::AddItemActionExecute(TObject *Sender)
{
	ChangeItemActionExecute(true);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::AddItemActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (!IsSpecial && !DescEdit->Text.IsEmpty());
}

//---------------------------------------------------------------------------
//fBNg̎Q
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RefDirButtonClick(TObject *Sender)
{
	UnicodeString dnam = DirEdit->Text;
	if (UserModule->SelectDirEx(_T("o^fBNg"), dnam)) DirEdit->Text = to_path_name(dnam);
}

//---------------------------------------------------------------------------
//pXRs[
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::CopyPathActionExecute(TObject *Sender)
{
	copy_to_Clipboard(ExcludeTrailingPathDelimiter(GetCurDirItem()));
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::CopyPathActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !GetCurDirItem().IsEmpty();
}

//---------------------------------------------------------------------------
//fBNg̃vpeB
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::PropertyActionExecute(TObject *Sender)
{
	UnicodeString dnam = GetCurDirItem();
	if (!dnam.IsEmpty()) ShowPropertyDialog(dnam);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::PropertyActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (RegDirListBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
//ꗗ[NXgƂĕۑ
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::SaveAsWorkActionExecute(TObject *Sender)
{
	UnicodeString fnam;
	UserModule->PrepareSaveDlg(LoadUsrMsg(USTR_SaveAs, _T("[NXg")).c_str(), 
		F_FILTER_NWL, _T("SpecialDir.nwl"), WorkListPath);

	if (UserModule->SaveDlg->Execute()) {
		std::unique_ptr<TStringList> lst(new TStringList());
		lst->Assign(RegDirListBox->Items);
		if (!saveto_TextUTF8(UserModule->SaveDlg->FileName, lst.get()))
			msgbox_ERR(LoadUsrMsg(USTR_FaildSave, ExtractFileName(UserModule->SaveDlg->FileName)));
	}
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::SaveAsWorkActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = IsSpecial;
	ap->Enabled = IsSpecial;
}

//---------------------------------------------------------------------------
//IvV̊J
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::SetOptBtn()
{
	if (ScrBarStyle==0)
		set_ControlRBCorner(RegDirListBox, BlankPanel);
	else
		ListScrPanel->SetRBCornerPanel(BlankPanel);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::ChgOptBtnClick(TObject *Sender)
{
	OptPanel->Visible	= !OptPanel->Visible;
	BlankPanel->Visible = !OptPanel->Visible;
	ListScrPanel->UpdateKnob();
	SetOptBtn();
}

//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift,
		IsSpecial? _T(HELPTOPIC_FL) _T("#SpecialDirList") : _T("hid00054.htm"));
}
//---------------------------------------------------------------------------

